#include<stdio.h>
#include<stdlib.h>
#include<unistd.h>
#include<string.h>
#include<arpa/inet.h>
#include<sys/types.h>
#include<sys/socket.h>
#include<netinet/in.h>
#include<pthread.h>
#include<fcntl.h>
#include<netinet/sctp.h>


#define BUFSIZE  1024

void * clnt_connection(void *  arg);
void  * read_message(void * arg);
void error_handling(char * message);


int clnt_number=0;
int clnt_socks[10];
pthread_mutex_t mutx;

int main(int argc, char **argv)
{
	int serv_sock;
	int clnt_sock;
	struct sockaddr_in serv_addr;
	struct sockaddr_in clnt_addr;
	int clnt_addr_size;
	pthread_t connection_thread,read_thread;
	
	
	if(pthread_mutex_init(&mutx,NULL))
	{
		error_handling("mutex init error");
	}
	if(argc!=2)
	{
			printf("Usage :%s <port>\n",argv[0]);
	}
	serv_sock=socket(PF_INET,SOCK_STREAM,IPPROTO_SCTP);
	
	memset(&serv_addr,0,sizeof(serv_addr));
	
	serv_addr.sin_family=AF_INET;
	serv_addr.sin_addr.s_addr=htonl(INADDR_ANY);
	serv_addr.sin_port=htons(atoi(argv[1]));
	
	if(bind(serv_sock,(struct sockaddr *)&serv_addr,sizeof(serv_addr))==-1)
	{
		error_handling("bind() error");
	}
	
	if(listen(serv_sock,5)==-1)
	{
		error_handling("listen() error");
	}
	
	while(1)
	{
		clnt_addr_size=sizeof(clnt_addr);
		clnt_sock=accept(serv_sock,(struct sockaddr*)&clnt_addr,&clnt_addr_size);
		pthread_mutex_unlock(&mutx);
		
		pthread_create(&connection_thread, NULL, clnt_connection, (void*)clnt_sock);
	//	pthread_create(&read_thread,NULL,read_message,(void *)clnt_sock);
	        
		printf("new client ip= %s\n",inet_ntoa(clnt_addr.sin_addr));
		
	}
	return 0;
}

void * clnt_connection(void * arg)
{
	int clnt_sock=(int)arg;
	int str_len=0;
	char message[BUFSIZE];
	int i;
	
	int fdin;
	int flags;
	int n;
	char inbuf[BUFSIZE];

	
	flags=O_RDONLY;
	
	if((fdin=open("boy.asf",flags))==-1)
	{
		perror("file open error\n");
		exit(1);
	}
	

	while((n=read(fdin,inbuf,BUFSIZE))>0)
	{
		//	printf("%s",inbuf);
			write(clnt_sock,inbuf,BUFSIZE);
		//	printf("%s              .....  \n",inbuf);
			
		
	}
	write(clnt_sock,"end",3);
	printf("complet file transmission\n");
	close(fdin);
	
}


void * read_message(void *arg)
{

 
}


void error_handling(char * message)
{
	fputs(message, stderr);
	fputc('\n',stderr);
	exit(1);
}